//=============================================================================
//  TImageList ɉ摜i[
//  ColorDepth ̒l cd8bit ɂꍇ̃eXg
//  TImageList Ɋi[摜 ColorDepth ̒lɉF̃rbg}bv
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2022N1118 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 10 rh 19043 Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ImgList, Vcl.ComCtrls,
  Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ImageList1: TImageList;
    ListView1: TListView;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Vcl.Imaging.pngimage,
  Vcl.Imaging.GIFImg;

{$R *.dfm}

//=============================================================================
//  tH[̏
//  ColorDepth ̒l cd8bit ɂꍇ̃eXg
//  ̏ꍇCTImageList Ɋi[̂ 8 rbgF ( 356 F ) ̃rbg}bv
//
//  ߏԂ̊mFp TListView ̔wiFݒ
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  ImageList1.SetSize(128, 128);
  ImageList1.ColorDepth := cd8Bit;

  ListView1.Items.Clear;
  ListView1.Color := clSilver;
  ListView1.ViewStyle   := vsIcon;
  ListView1.LargeImages := ImageList1;
end;

//=============================================================================
//  32 rbgF̃At@`lt̉摜 TImageList Ɋi[
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LBitmap   : TBitmap;
  LPngImage : TPngImage;
  LIcon     : TIcon;
  LIndex    : Integer;
begin
  ListView1.Items.Clear;
  ImageList1.Clear;

  LBitmap := TBitmap.Create;
  try
    // 32 rbg̃At@`ltrbg}bv
    LBitmap.LoadFromFile('..\Images\images_32bit.bmp');
    ImageList1.Add(LBitmap, nil);
  finally
    FreeAndNil(LBitmap);
  end;

  LBitmap   := TBitmap.Create;
  LPngImage := TPngImage.Create;
  try
    // 32 rbg PNG `摜
    LPngImage.LoadFromFile('..\Images\images_32bit.png');
    LBitmap.Assign(LPngImage);
    ImageList1.Add(LBitmap, nil);
  finally
    FreeAndNil(LBitmap);
    FreeAndNil(LPngImage);
  end;

  LIcon := TIcon.Create;
  try
    // 32 rbg̃ACR摜
    LIcon.LoadFromFile('..\Images\Images_32bIT.ico');
    ImageList1.AddIcon(LIcon);
  finally
    FreeAndNil(LIcon);
  end;


  // TListView  TImageList ̉摜`
  for LIndex := 0 to ImageList1.Count - 1 do begin
    ListView1.Items.Add.Caption := 'Image - ' + IntToStr(LIndex);
    ListView1.Items[LIndex].ImageIndex := LIndex;
  end;
end;

//=============================================================================
//  24 rbgFȉ̉摜ǂݍ TImageList Ɋi[
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LBitmap     : TBitmap;
  LMaskBitmap : TBitmap;
  LGifImage   : TGIFImage;
  LIcon       : TIcon;
  LIndex      : Integer;
begin
  ListView1.Items.Clear;
  ImageList1.Clear;

  LBitmap     := TBitmap.Create;
  LMaskBitmap := TBitmap.Create;
  try
    // 24 rbgF̃rbg}bv摜
    LBitmap.LoadFromFile('..\Images\simple_24bit.bmp');

    LMaskBitmap.Assign(LBitmap);
    LMaskBitmap.Mask(LBitmap.TransparentColor);
    ImageList1.Add(LBitmap, LMaskBitmap);
  finally
    FreeAndNil(LBitmap);
    FreeAndNil(LMaskBitmap);
  end;

  LBitmap     := TBitmap.Create;
  LMaskBitmap := TBitmap.Create;
  LGifImage   := TGIFImage.Create;
  try
    // GIF `̉摜 ( 256 F )
    LGifImage.LoadFromFile('..\Images\Simple_8bit.gif');
    LBitmap.SetSize(LGifImage.Width, LGifImage.Height);

    LGifImage.Transparent := False;
    LBitmap.Canvas.Draw(0, 0, LGifImage);
    LMaskBitmap.Assign(LBitmap);
    LMaskBitmap.Mask(LGifImage.Bitmap.TransparentColor);
    ImageList1.Add(LBitmap, LMaskBitmap);
  finally
    FreeAndNil(LBitmap);
    FreeAndNil(LMaskBitmap);
    FreeAndNil(LGifImage);
  end;

  LIcon := TIcon.Create;
  try
    // 24 rbgF̃ACR摜
    LIcon.LoadFromFile('..\Images\Images_24bIt.ico');
    ImageList1.AddIcon(LIcon);

    // 8 rbgF̃ACR摜
    LIcon.LoadFromFile('..\Images\Images_8bIt.ico');
    ImageList1.AddIcon(LIcon);
  finally
    FreeAndNil(LIcon);
  end;


  // TListView  TImageList ̉摜`
  for LIndex := 0 to ImageList1.Count - 1 do begin
    ListView1.Items.Add.Caption := 'Image - ' + IntToStr(LIndex);
    ListView1.Items[LIndex].ImageIndex := LIndex;
  end;
end;

end.
