//=============================================================================
//  TImageList ɉ摜i[
//  TListView ɂ摜`̃Xy[X
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2022N1118 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 10 rh 19043 Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ImgList, Vcl.ComCtrls,
  Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ImageList1: TImageList;
    ListView1: TListView;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure SetImageSpace;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Winapi.CommCtrl;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  ImageList1.SetSize(128, 128);
  ImageList1.ColorDepth := cd32Bit;

  ListView1.Items.Clear;
  ListView1.ViewStyle   := vsIcon;
  ListView1.LargeImages := ImageList1;
end;

//=============================================================================
//  32 rbgF̃rbg}bv摜 TImageList iɊi[
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LBitmap : TBitmap;
  LIndex  : Integer;
begin
  SetImageSpace;

  ListView1.Items.Clear;
  ImageList1.Clear;

  LBitmap := TBitmap.Create;
  try
    // 128 x128 ̎lp`̉摜ǂݍ ( 32 rbgF )
    LBitmap.LoadFromFile('..\Images\Frame_32bit.bmp');

    //  TImageList Ɋi[
    ImageList1.Add(LBitmap, nil);
    ImageList1.Add(LBitmap, nil);
    ImageList1.Add(LBitmap, nil);
    ImageList1.Add(LBitmap, nil);
    ImageList1.Add(LBitmap, nil);
    ImageList1.Add(LBitmap, nil);
  finally
    FreeAndNil(LBitmap);
  end;


  // TListView  TImageList ̉摜`
  for LIndex := 0 to ImageList1.Count - 1 do begin
    ListView1.Items.Add.Caption := 'Image - ' + IntToStr(LIndex);
    ListView1.Items[LIndex].ImageIndex := LIndex;
  end;
end;

//-----------------------------------------------------------------------------
//  TListView ł̉摜`̊ԊuύX
//  uses  Winapi.CommCtrl Kv
//-----------------------------------------------------------------------------
procedure TForm1.SetImageSpace;
{$WRITEABLECONST ON}
const
  LImgFlag : Boolean = False;
{$WRITEABLECONST OFF}
var
  LWidth  : WORD;
  LHeight : WORD;
begin
  // gO
  if LImgFlag then begin
    LWidth  := ImageList1.Width + 25;
    LHeight := ImageList1.Height + 25;
  end else begin
    // ftHg̐ݒl
    LWidth  := WORD(-1);
    LHeight := WORD(-1);
  end;
  LImgFlag := not LImgFlag;

  // 摜̕`Ԋu ( Xy[X ) ݒ
  ListView_SetIconSpacing(ListView1.Handle, LWidth, LHeight);
end;

end.
